<template>
  <q-page class="q-px-md q-mt-md">
    <q-card>
      <q-card-section>
        <div class="row q-gutter-x-sm">
          <div
            class="col-auto text-right"
            style="line-height: 40px; min-width: 80px;"
          >
            ประเภทเกม
          </div>
          <div class="col">
            <q-checkbox
              v-model="game_type"
              :key="item.code"
              v-for="item in groupList"
              :val="item.code"
              :label="item.code"
            />
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <div class="row q-gutter-x-sm">
          <div
            class="col-auto text-right"
            style="line-height: 50px; min-width: 80px;"
          >
            ผู้ให้บริการ
          </div>
          <div class="col-10 col-md-auto">
            <q-select
              outlined
              dense
              v-model="provider_code"
              multiple
              :options="providerList"
              option-value="code"
              option-label="name"
              emit-value
              style="min-width: 250px; "
            >
              <template v-if="provider_code.length > 0" v-slot:append>
                <q-icon
                  name="cancel"
                  @click.stop="provider_code = []"
                  class="cursor-pointer"
                />
              </template>
            </q-select>
          </div>
        </div>
      </q-card-section>
      <q-card-section>
        <StartDateEndDateFilterComponent :filter="dateFilter" />
      </q-card-section>
      <q-card-section>
        <div class="row reverse">
          <div class="col-md-auto">
            <q-input
              bg-color="grey-13"
              @keydown.enter="onSearch"
              v-model.trim="filter.username"
              placeholder="ค้นหา อย่างน้อย 3 ตัวอักษร"
              outlined
              dense
            >
              <template v-slot:prepend>
                <q-icon name="search" class="pointer" />
              </template>
              <template v-slot:append>
                <q-icon
                  v-if="filter.username !== ''"
                  name="close"
                  @click="
                    e => {
                      filter.username = '';
                      onRequest({
                        pagination: pagination,
                        ...filter
                      });
                    }
                  "
                  class="cursor-pointer"
                />
              </template>
              <template v-slot:after>
                <q-btn color="green" @click.prevent="onSearch" icon="search"
                  >ค้นหา</q-btn
                >
              </template>
            </q-input>
          </div>
        </div>
      </q-card-section>
      <q-table
        :rows-per-page-options="[15, 25, 50]"
        :pagination.sync="pagination"
        :loading="loading"
        :data="this.data"
        separator="cell"
        row-key="id"
        @request="onRequest"
      >
        <template slot="header" slot-scope="props" :props="props">
          <q-tr>
            <q-th rowspan="2" class="bg-blue-9 text-white">
              ยูสเซอร์เนม
            </q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">บทบาท</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">สกุลเงิน</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">จำนวน</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ครั้ง</q-th>
            <q-th rowspan="2" class="bg-blue-9 text-white">ถือสู้</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">สมาชิก</q-th>
            <q-th colspan="1" class="bg-blue-10 text-white">เอเย่น</q-th>
            <q-th v-if="role < 5" colspan="1" class="bg-blue-10 text-white"
              >ซีเนียร์</q-th
            >
            <q-th v-if="role < 4" colspan="1" class="bg-blue-10 text-white"
              >ผู้ถือหุ้น</q-th
            >
            <q-th colspan="1" class="bg-blue-10 text-white">คอมปะนี</q-th>
            <q-th v-if="role <= 2" colspan="1" class="bg-blue-10 text-white"
              >Smart Bet</q-th
            >
            <q-th v-if="role < 2" colspan="1" class="bg-blue-10 text-white"
              >Provider</q-th
            >
          </q-tr>
          <q-tr>
            <q-th
              class="bg-light-blue-5 text-white"
              v-for="index in role < 2 ? 7 : 6 - role + 2"
              :key="index"
              >W/L
            </q-th>
          </q-tr>
        </template>
        <template slot="body" slot-scope="props" :props="props">
          <MemberRow
            :key="`${props.row.id}_${+new Date()}`"
            :filter="extendParameter"
            :row="props.row"
          />
        </template>
        <template v-slot:loading>
          <q-inner-loading showing color="primary" />
        </template>
      </q-table>
    </q-card>
  </q-page>
</template>
<script>
import { mapState, mapGetters, mapActions } from "vuex";
import MemberRow from "./member_tr";
import { SessionStorage, LocalStorage } from "quasar";
import StartDateEndDateFilterComponent from "components/StartDateEndDateFilterComponent";
const sessionKey = "filter_report_member_";
const username = LocalStorage.getItem("username");
export default {
  name: "Report-Member",
  components: {
    MemberRow,
    StartDateEndDateFilterComponent
  },
  data() {
    return {
      data: [],
      loading: false,
      dateFilter: {
        startDate: new Date(),
        startTime: new Date(new Date().setHours(0, 0, 0, 0)),
        endDate: new Date(),
        endTime: new Date(new Date().setHours(23, 59, 59, 999))
      },
      game_type: [],
      provider_code: [],
      filter: {
        username: "",
        parent_id: undefined,
        level: undefined
      },
      pagination: {
        sortBy: "desc",
        descending: false,
        page: 1,
        rowsPerPage: 15,
        rowsNumber: 0
      },
      groupList: [],
      providerList: []
    };
  },
  async created() {
    document.title = "Report";
    if (SessionStorage.getItem(`group_list_filter`)) {
      this.groupList = SessionStorage.getItem(`group_list_filter`);
    } else {
      try {
        const {
          data: { resultsz }
        } = await this.load_list();
        if (results) {
          this.groupList = results.filter(
            (item, index) =>
              results.findIndex(r => r.code == item.code) == index
          );
          SessionStorage.set("group_list_filter", this.groupList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
    }
    if (SessionStorage.getItem(`provider_list_filter`)) {
      this.providerList = SessionStorage.getItem(`provider_list_filter`);
    } else {
      try {
        const { data } = await this.load_provider();
        if (data) {
          this.providerList = data
            .filter(
              (item, index) => data.findIndex(r => r.code == item.code) == index
            )
            .map(x => {
              return {
                code: x.code,
                name: x.name
              };
            });
          SessionStorage.set("provider_list_filter", this.providerList);
        }
      } catch (ex) {
        this.$dialog.errorException(ex); 
      }
    }
    if (Object.keys(this.$route.query).length > 0) {
      const {
        datetime_start,
        datetime_end,
        game_type,
        provider_code
      } = this.$route.query;
      if (datetime_start) {
        this.dateFilter.startDate = dayjs(
          datetime_start.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
        this.dateFilter.startTime = dayjs(
          datetime_start.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
      }
      if (datetime_end) {
        this.dateFilter.endDate = dayjs(
          datetime_end.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
        this.dateFilter.endTime = dayjs(
          datetime_end.replace(/Z/g, ""),
          "YYYY-MM-DDTHH:mm:ss"
        );
      }
      if (game_type) {
        this.game_type = game_type.split(",");
      }
      if (provider_code) {
        this.provider_code = provider_code.split(",");
      }
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    } else {
      this.game_type = this.groupList.map(x => x.code);
    }
  },
  computed: {
    ...mapState("auth", ["role"]),
    items() {
      return this.data;
    },
    extendParameter() {
      const parameters = Object.assign(
        {},
        this.getFilterParameter({ filter: this.filter })
      );
      delete parameters.username;
      parameters.game_type = this.game_type.join(",");
      parameters.provider_code = this.provider_code.join(",");
      return parameters;
    }
  },
  methods: {
    ...mapActions("report/v2", ["load_dashboard"]),
    ...mapActions("group/v2", ["load_list"]),
    ...mapActions("provider", { load_provider: "load" }),
    async recoveryBack() {
      let filter = SessionStorage.getItem(
        `${this.$route.path}_${this.$route.name}_${sessionKey}_${username}`
      );
      if (filter) {
        this.filter = filter;
        await this.onSearch();
      }
    },
    async recoveryQueryString() {},
    getDateTime(date, time) {
      let dateFormat = "YYYY-MM-DD";
      let timeFormat = "HH:mm:ss";
      return (
        dayjs(
          `${dayjs(date).format(dateFormat)} ${dayjs(time).format(timeFormat)}`,
          "YYYY-MM-DD HH:mm:ss"
        )
          .utc()
          .format(`${dateFormat} ${timeFormat}`) + "Z"
      );
    },
    getFilterParameter({ filter = this.filter, pagination = this.pagination }) {
      if (this.$route.meta.level) {
        filter.level = this.$route.meta.level;
      }
      if (this.$route.params.id) {
        filter.parent_id = this.$route.params.id;
      } else {
        delete filter.parent_id;
      }
      let datetime_start = undefined;
      let datetime_end = undefined;
      if (this.dateFilter.startDate) {
        if (this.dateFilter.startTime) {
          datetime_start = this.getDateTime(
            this.dateFilter.startDate,
            this.dateFilter.startTime
          );
        } else {
          datetime_start = this.getDateTime(
            this.dateFilter.startDate,
            new Date().setHours(0, 0, 0, 0)
          );
        }
      }
      if (this.dateFilter.endDate) {
        if (this.dateFilter.endTime) {
          datetime_end = this.getDateTime(
            this.dateFilter.endDate,
            this.dateFilter.endTime
          );
        } else {
          datetime_end = this.getDateTime(
            this.dateFilter.endDate,
            new Date().setHours(23, 59, 59, 999)
          );
        }
      }
      return {
        game_type: this.game_type.join(","),
        provider_code: this.provider_code.join(","),
        ...filter,
        ...pagination,
        datetime_start,
        datetime_end
      };
    },
    async onRequest(props) {
      this.loading = true;
      try {
        const parameters = this.getFilterParameter(props);
        const {
          data: {
            results: {
              docs: results,
              page: resultPage,
              limit: perPage,
              totalPages: total
            }
          }
        } = await this.load_dashboard({
          ...parameters
        });

        this.data = results;
        this.pagination.page = resultPage ?? 1;
        this.pagination.rowsPerPage = perPage;
        this.pagination.rowsNumber = total;
      } catch (ex) {
        this.$dialog.errorException(ex);
      }
      this.loading = false;
    },
    async onSearch() {
      await this.onRequest({
        pagination: this.pagination,
        filter: this.filter
      });
    },
    beforeRouteLeave(to, from, next) {
      if (to.path.startsWith("/v2/report/member/")) {
        SessionStorage.set(
          `${this.$route.path}_${this.$route.name}_${sessionKey}_${username}`,
          this.filter
        );
      }
      next();
    }
  }
};
</script>
<style lang="scss">
label {
  margin: 8px 0;
}

.el-input__inner,
.q-field--outlined .q-field__control:before {
  border-color: black;
}
</style>
